{
  funkcje oslugujace sterte:
  Huf - drzewo kodow Huffmana, potrzebne do porownywania elementow
  h   - tablica numerow wierzcholkow z drzewa Huf
  s   - rozmiar sterty
}

procedure HeapUp(Huf:PTHufTree; var h:array of integer; s:integer);
var
p,c,t:integer;
begin
 t:=h[s];
 c:=s; p:=s shr 1;
 while ( Huf^.Node[h[p]].Freq > Huf^.Node[t].Freq ) do
  begin
   h[c]:=h[p];
   c:=p; p:=p shr 1;
  end;
 h[c]:=t;
end;

procedure HeapDown(Huf:PTHufTree; var h:array of integer; s,k:integer);
var
p,c,t:integer;
_break:boolean;
begin
 t:=h[k];
 p:=k; c:=p shl 1;
 _break:=false;
 while (c<=s) and not _break do
  begin
   if (c<s) and (Huf^.Node[h[c+1]].Freq < Huf^.Node[h[c]].Freq ) then inc(c);
   if ( Huf^.Node[h[c]].Freq < Huf^.Node[t].Freq) then
    begin
     h[p]:=h[c];
     p:=c;
     c:=c shl 1;
    end
   else _break:=true;
  end;
 h[p]:=t;
end;

{ dodanie elementu }
procedure HeapInsert(Huf:PTHufTree; var h:array of integer; var s:integer; e:integer);
begin
 inc(s);
 h[s]:=e;
 HeapUp(Huf, h, s);
end;

{ pobranie elementu najmniejszego }
function HeapGetRoot(Huf:PTHufTree; var h:array of integer; var s:integer):integer;
var
r:integer;
begin
 r:=h[1];
 h[1]:=h[s];
 dec(s);
 HeapDown(Huf,h,s,1);
 HeapGetRoot:=r;
end;

{ utworzenie sterty z tablicy }
procedure HeapConstruct(Huf:PTHufTree; var h:array of integer; s:integer);
var i:integer;
begin
 for i:=s div 2 downto 1 do HeapDown(Huf,h,s,i);
end;